;; blitter.asm                               letzte Aenderung: 20.6.2014
;* Ausprobieren einer Idee
;*
;-----------------------------------------------------------------------------

.equ F_CPU=20000000		;16 MHz oder 20 MHz
.nolist
;.include "m8def.inc"		;ATmega8
.include "m1284Pdef.inc"	;ATmega1284P

.equ MU=F_CPU/1000000		;MU = Anzahl Takte fuer 1 Microsekunde
.def zero=r5
.def sreg_save=r4

	rjmp main

;-----------------------------------------------------------------------------
;; Macros

.macro mult16
.endm
.macro mult16_8_8	;multiplizieren mit 16-Bit-Ergebnis
			;Beispiel: mult [r16,r17] --> r17:r16=Resultat
	push r0
	push r1
	mul @0,@1
	movw @0,r0
	pop r1
	pop r0			;11 Takte
.endm
.macro mult16_16_i	;multiplizieren mit 16-Bit-Ergebnis
			;Beispiel: mult [r16,10] --> r17:r16=Resultat
	push r0
	push r1
	ldi @0,@2
	mul @1,@0
	movw @1,r0
	pop r1
	pop r0			;12 Takte
.endm

;-----------------------------------------------------------------------------
; Variablen im SRAM:
.list
                .DSEG
testbuffer:	.BYTE 256
quellzeiger:	.BYTE 1		; von hier soll kopiert werden
zielzeiger:	.BYTE 1		; hier sollen Daten landen
groesse:	.BYTE 1		; so viele Bytes sollen kopiert werden
		.CSEG

kopieren:	;Bytes kopieren
	push r16
	push r17
	push XL
	push XH
	push YL
	push YH

	lds r16, quellzeiger
	ldi XL, low(testbuffer)
	ldi XH, high(testbuffer)
	movw YL,XL
	add XL, r16
	adc XH, zero
	lds r16, zielzeiger
	add YL, r16
	adc YH, zero
	lds r16, groesse
_L1:	ld r17, X+
	st Y+, r17
	dec r16			;6 Takte pro Schlaufe
	brne _L1

	pop YH
	pop YL
	pop XH
	pop XL
	pop r17
	pop r16
	ret			;mind. 50 Takte (inklusive rcall und ret)
	;; total anzahl Takte: 50 + (groesse-1)*6

blitten:	;nur N Bytes kopieren (r18=N)
	push r16
	push r17
	push r19
	push XL
	push XH
	push YL
	push YH

	lds r16, quellzeiger
	ldi XL, low(testbuffer)
	ldi XH, high(testbuffer)
	movw YL,XL
	add XL, r16
	adc XH, zero
	lds r16, zielzeiger
	add YL, r16
	adc YH, zero
	lds r16, groesse
	mov r19, r18		;r19 = Angefragte Anzahl zu kopierende Bytes
	cp r16, r18		;r16<r18?
	brcc _L1
	mov r18, r16		;ja: r18 auf r16 beschraenken
_L1:	sub r16, r18		;r16-=r18
	sts groesse, r16	;Restliche groesse speichern
	mov r16, r18
_L2:	ld r17, X+
	st Y+, r17
	dec r16			;6 Takte pro Schlaufe
	brne _L2
	lds r16, zielzeiger
	add r16, r18
	sts zielzeiger, r16
	lds r16, quellzeiger
	add r16, r18
	sts quellzeiger, r16
	sub r19, r18		;Weniger Bytes als angefragt kopiert?
	breq _L4		;nein--> fertig
	nop
_L3:	nop
	nop
	nop
	dec r19
	brne _L3		;n*6 Takte zusaetzlich warten
	nop
_L4:	pop YH
	pop YL
	pop XH
	pop XL
	pop r19
	pop r17
	pop r16
	ret			;mind. 75 Takte (inklusive rcall und ret)
	;; total anzahl Takte: 75 + N*6

;-----------------------------------------------------------------------------
; Hauptprogramm

main:	ldi r16, low(RAMEND)
        out SPL, r16		; Init Stackpointer L
        ldi r16, high(RAMEND)
        out SPH, r16		; Init Stackpointer H
	clr zero
mainloop:
	rjmp mainloop

; Ende Hauptprogramm
;-----------------------------------------------------------------------------
